//////////////////////////////////////////////////////
#include <acknex.h>
/////////////////////////////////////////////////////
// Winter 2008 contest
// "No external files" lite-C contest
// Entry: Vaders
/////////////////////////////////////////////////////
// Controls:
//
// Middle Panel - Play Game
// Mouse moving - Look around and moving the Player
// Left Mouse Button - Fire
// Mouse wheel - Zoom in & out
// Esc - Exit
//
// Created by Robert Judycki aka rojart
//////////////////////////////////////////////////////

#define API(name,lib)  #define PRAGMA_API name;lib!name
#define DECLARE_HANDLE(name) typedef HANDLE name
#define MIDI_MAPPER -1
#define MMSYSERR_NOERROR 0
#define CALLBACK_NULL 0x0

#define sm0_x sys_metrics(0)
#define sm1_y sys_metrics(1)
#define hsmx sm0_x/2
#define hsmy sm1_y/2

#define C_RED     vector(  0,  0,255)
#define C_GREEN   vector(  0,255,  0)
#define C_BLUE    vector(255,  0,  0)
#define C_YELLOW  vector(  0,255,255)
#define C_CYAN    vector(255,255,  0)
#define C_MAGENTA vector(255,  0,255)
#define C_WHITE   vector(255,255,255)
#define C_GRAY    vector( 64, 64, 64)
#define C_BLACK   vector(  0,  0,  0)
#define C_BRAUN   vector( 64,128,128)

DECLARE_HANDLE(HMIDIOUT);
HMIDIOUT hMidiout;

DWORD __stdcall midiOutOpen(DWORD*,DWORD,DWORD,DWORD,DWORD);
DWORD __stdcall midiOutShortMsg(DWORD,DWORD);
DWORD __stdcall midiOutReset(DWORD);
DWORD __stdcall midiOutClose(DWORD);

API(midiOutOpen,winmm)
API(midiOutShortMsg,winmm)
API(midiOutReset,winmm)
API(midiOutClose,winmm)

BMAP* b_sky1 = "#128x128x32";BMAP* b_sky2 = "#128x128x32";BMAP* b_sky3 = "#128x128x32";
BMAP* b_sky4 = "#128x128x32";BMAP* b_sky5 = "#128x128x32";BMAP* b_sky6 = "#128x128x32";

BMAP* b_wpoint = "#1x1x32";
BMAP* b_rpoint = "#1x1x32";
BMAP* b_gpoint = "#1x1x32";
char* c_wpoint = "bmap = b_wpoint; pos_x = 0; pos_y = 0; flags = SHOW;";
char* c_rpoint = "bmap = b_rpoint; pos_x = 0; pos_y = 0; flags = SHOW;";
char* c_gpoint = "bmap = b_gpoint; pos_x = 0; pos_y = 0; flags = SHOW;";

BMAP* b_wdata  = "#112x8x32";
BMAP* b_rdata  = "#32x8x32";
BMAP* b_gdata  = "#48x8x32";

BMAP* b_bullet  = "#8x16x32";
BMAP* b_abullet = "#8x16x32";


BMAP* b_create_red     = "#256x128x32";
BMAP* b_create_green   = "#256x128x32";
BMAP* b_create_blue    = "#256x128x32";
BMAP* b_create_yellow  = "#256x128x32";
BMAP* b_create_cyan    = "#256x128x32";
BMAP* b_create_magenta = "#256x128x32";
BMAP* b_create_white   = "#256x128x32";
BMAP* b_create_gray    = "#256x128x32";
BMAP* b_create_black   = "#256x128x32";
BMAP* b_create_braun   = "#256x128x32";

BMAP* b_arrowa;
BMAP* b_arrowx   = "#100x100x32";

BMAP* b_empty;
BMAP* b_menu2;
BMAP* b_explode;

ENTITY* e_menu0;ENTITY* e_menu1;ENTITY* e_menu2;ENTITY* e_menu3;ENTITY* e_menu4;ENTITY* e_menu5;
ENTITY* e_menu6;ENTITY* e_menu7;ENTITY* e_menu8;ENTITY* e_menu9;ENTITY* e_menu10;

ENTITY* e_bullet;
ENTITY* e_player;
ENTITY* e_explode;
ENTITY* e_ufo;
ENTITY* enemies1[12];
ENTITY* enemies2[12];
ENTITY* enemies3[12];
ENTITY* enemies4[12];
ENTITY* enemies5[12];
ENTITY* enemies6[12];

int midiport       = 0;
int enemies_nr     = 72;
var sense_x        = 1;
var speed_x        = 5;
var speed_y        = 150;
var players_score  = 0;
var players_energy = 100;
var index          = 0;
var i              = 0;
var d              = 0;
var n              = 0;
var menu_status    = 1;
var ufo_move       = 0;

var mindist =  100; // Mouse wheel
var maxdist = 2000;

void init_menu();
void game_over();
void a_exp_a1();

PANEL* new_element[1536];

PANEL* p_sky1 = 
{
	bmap = b_sky1; pos_x =   0; pos_y = 0;
	digits (64,   0, "VADERS", "System#40", 0, 0);
	digits (64,  28, "Created by rojart",   "Arial#15", 0, 0);
	digits (64,  40, "Controls:", "Arial#12", 0, 0);
	digits (64,  50, "Middle Panel - Play Game", "Arial#12", 0, 0);
	digits (64,  60, "Left Mouse Button - Fire", "Arial#12", 0, 0);
	digits (64,  70, "Mouse wheel - Zoom in/out", "Arial#12", 0, 0);
	digits (64,  78, "Esc - Exit", "Arial#13", 0, 0);
	digits (64,  90, "Winter 2008 contest", "Arial#12", 0, 0);
	digits (64, 100, "No external files",   "Arial#12", 0, 0);
}

PANEL* p_sky2 = {bmap = b_sky2; pos_x = 128; pos_y = 0;}
PANEL* p_sky3 = {bmap = b_sky3; pos_x = 256; pos_y = 0;}
PANEL* p_sky4 = {bmap = b_sky4; pos_x = 384; pos_y = 0;}
PANEL* p_sky5 = {bmap = b_sky5; pos_x = 512; pos_y = 0;}
PANEL* p_sky6 = {bmap = b_sky6; pos_x = 640; pos_y = 0;}

PANEL* p_wdata = {bmap = b_wdata; pos_x =   0; pos_y = 0;}
PANEL* p_rdata = {bmap = b_rdata; pos_x = 112; pos_y = 0;}
PANEL* p_gdata = {bmap = b_gdata; pos_x = 144; pos_y = 0;}

PANEL* p_play =
{
	red = 0; green = 0; blue = 255;
	digits (0, 0, "PLAY", System#80b, 0, 0);
}

PANEL* p_game_over =
{
	red = 255; green = 0; blue = 0;
	digits (0, 0, "GAME OVER", System#80b, 0, 0);
}

PANEL* p_score =
{
	red = 0; green = 0; blue = 255;
	digits (10, 0, "SCORE : %.f", System#80b, 1, players_score);
}

PANEL* p_energy =
{
	red = 255; green = 0; blue = 0;
	digits (0, 0, "ENERGY : %.f", System#80b, 1, players_energy);
}

PANEL* p_menu =
{
	red = 55; green = 55;	blue = 55;
	digits (0, 0, "VADERS", System#80b, 0, 0);
}

MATERIAL* mtl_zwenable =
{
effect ="technique zwenable{pass one{zWriteEnable = true;alphaTestEnable = true;}}
technique fallback { pass one { } }";
}

void v_border(BMAP* bmap)
{   
	var alpha  = 50;
	var pixel  = pixel_for_vec(C_WHITE,alpha,bmap_lock(bmap,0));
	var width  = bmap_width(bmap);
	var height = bmap_height(bmap);
	var i, j;
	
	for (i=0; i<width; i++) 
	{  
		for (j=0; j<5; j++) 
		{  
			pixel_to_bmap(bmap,i,j,pixel);
			pixel_to_bmap(bmap,i,height-1-j,pixel);
		}
	} 
	
	for (i=0; i<height; i++) 
	{   
		for (j=0; j<5; j++) 
		{  
			pixel_to_bmap(bmap,j,i,pixel); 
			pixel_to_bmap(bmap,width-1-j,i,pixel);
			
		}
	}
	bmap_unlock(bmap); 
}

void v_border_erase(BMAP* bmap,COLOR* color,var alpha)
{   
	var pixel  = pixel_for_vec(color,alpha,bmap_lock(bmap,0));
	var width  = bmap_width(bmap);
	var height = bmap_height(bmap);
	var i, j;
	
	for (i=0; i<width; i++) 
	{  
		for (j=0; j<10; j++) 
		{  
			pixel_to_bmap(bmap,i,j,pixel);
			pixel_to_bmap(bmap,i,height-1-j,pixel);
		}
	} 
	
	for (i=0; i<height; i++) 
	{   
		for (j=0; j<10; j++) 
		{  
			pixel_to_bmap(bmap,j,i,pixel); 
			pixel_to_bmap(bmap,width-1-j,i,pixel);
		}
	}
	bmap_unlock(bmap); 
}

void v_border_white(BMAP* bmap,COLOR* color,var alpha)
{   
	var pixel  = pixel_for_vec(color,alpha,bmap_lock(bmap,0));
	var width  = bmap_width(bmap);
	var height = bmap_height(bmap);
	var i, j;
	
	for (i=5; i<width-5; i++) 
	{  
		for (j=0; j<10; j++) 
		{  
			pixel_to_bmap(bmap,i,j,pixel);
			pixel_to_bmap(bmap,i,height-1-j,pixel);
		}
	} 
	
	for (i=5; i<height-5; i++) 
	{   
		for (j=0; j<10; j++) 
		{  
			pixel_to_bmap(bmap,j,i,pixel); 
			pixel_to_bmap(bmap,width-1-j,i,pixel);
		}
	}
	bmap_unlock(bmap); 
}

void v_border_arc(BMAP* bmap,COLOR* color,var alpha)
{	
	var pixel = pixel_for_vec(color,alpha,bmap_lock(bmap,0));
	var width  = bmap_width(bmap);
	var height = bmap_height(bmap);
	var i, j, k = 6;
	
	for (i=0; i<k; i++) 
	{
		for (j=0; j<360; j++) 
		{
			var xc = sinv(j)*(5)   + k;
			var yc = cosv(j)*(5-i) + k;
			pixel_to_bmap(bmap,xc,yc,pixel);
			
			var xc = sinv(j)*(5)   + width-k;
			var yc = cosv(j)*(5-i) + k;
			pixel_to_bmap(bmap,xc,yc,pixel);
			
			var xc = sinv(j)*(5)   + width-k;
			var yc = cosv(j)*(5-i) + height-k;
			pixel_to_bmap(bmap,xc,yc,pixel);
			
			var xc = sinv(j)*(5)   + k;
			var yc = cosv(j)*(5-i) + height-k;
			pixel_to_bmap(bmap,xc,yc,pixel);
		}
	}
	bmap_unlock(bmap); 
}

void v_triangle(BMAP* bmap,COLOR* color,var alpha)
{   
	var pixel  = pixel_for_vec(color,alpha,bmap_lock(bmap,0));
	var width  = bmap_width(bmap);
	var height = bmap_height(bmap),px, py;
	
	for (py=0; py<height/2; py++)
	{
		for (px=0; px<width/2-py; px++)
		{
			pixel_to_bmap(bmap,px,py,pixel);
		}
	}
	bmap_unlock(bmap); 
}

void v_explode(BMAP* bmap,COLOR* color,var alpha)
{   
	var pixel  = pixel_for_vec(color,alpha,bmap_lock(bmap,0));
	var width  = bmap_width(bmap);
	var height = bmap_height(bmap);
	var i;
	
	for (i=0; i<width/2; i++) 
	{  
		pixel_to_bmap(bmap,i,0,pixel);
	} 
	
	for (i=0; i<height/2; i++) 
	{   
		pixel_to_bmap(bmap,0,i,pixel); 
	}
	bmap_unlock(bmap); 
}

void v_line(BMAP* bmap,COLOR* color,var alpha)
{   
	var pixel  = pixel_for_vec(color,alpha,bmap_lock(bmap,0));
	var width  = bmap_width(bmap);
	var height = bmap_height(bmap);
	var i;
	
	for (i=0; i<width/2; i++) 
	{  
		pixel_to_bmap(bmap,i,0,pixel);
	} 
	
	for (i=0; i<height/2; i++) 
	{   
		pixel_to_bmap(bmap,0,i,pixel); 
	}
	bmap_unlock(bmap); 
}

void v_circle(BMAP* bmap,COLOR* color,var alpha)
{	
	var pixel = pixel_for_vec(color,alpha,bmap_lock(bmap,0));
	var width  = bmap_height(bmap);
	var height = bmap_height(bmap);
	var i, j;
	
	for (i=0.01; i<height/2; i++) 
	{
		for (j=0.01; j<360; j++) 
		{
			var xc = sinv(j)*(width/2-2)  + width/2;
			var yc = cosv(j)*(height/2-i-2) + height/2;
			pixel_to_bmap(bmap,xc,yc,pixel);
		}
	}
	bmap_unlock(bmap); 
}

void v_arc(BMAP* bmap,COLOR* color,var alpha)
{	
	var pixel = pixel_for_vec(color,alpha,bmap_lock(bmap,0));
	var width  = bmap_width(bmap);
	var height = bmap_height(bmap);
	var i, j;
	
	for (i=0.01; i<height/2; i++) 
	{
		for (j=0.01; j<360; j++) 
		{
			var xc = sinv(j)*(width/2-i-1)  + width/2;
			var yc = cosv(j)*(height/2-i-1) + height/2;
			pixel_to_bmap(bmap,xc,yc,pixel);
		}
	}
	bmap_unlock(bmap); 
}

void a_menu0()
{
	wait(1);vec_set(my.pan, vector(0.01,0,0));
}

void a_menu1()
{
	wait(1);my.material = mtl_zwenable;set(my,UNLIT | LIGHT | TRANSLUCENT);vec_set(my.pan, vector(0.01,0,0));
	bmap_fill(b_create_red,C_RED,100);
	BMAP* b_menu1 = ent_setskin(my,b_create_red,1);
	wait(1);
	v_border_erase(b_menu1,C_BLACK,0);
	v_border_white(b_menu1,C_WHITE,100);
	v_border_arc  (b_menu1,C_WHITE,100);
}

void a_menu2()
{
	wait(1);my.material = mtl_zwenable;set(my,UNLIT | LIGHT | TRANSLUCENT);vec_set(my.pan, vector(0.01,0,0));
	bmap_fill(b_create_green,C_GREEN,100);
	BMAP* b_menu2 = ent_setskin(my,b_create_green,1);
	v_border_erase(b_menu2,C_BLACK,0);
	v_border_white(b_menu2,C_WHITE,100);
	v_border_arc  (b_menu2,C_WHITE,100);
}

void a_menu3()
{
	wait(1);my.material = mtl_zwenable;set(my,UNLIT | LIGHT | TRANSLUCENT);vec_set(my.pan, vector(0.01,0,0));
	bmap_fill(b_create_blue,C_BLUE,100);
	BMAP* b_menu3 = ent_setskin(my,b_create_blue,1);
	v_border_erase(b_menu3,C_BLACK,0);
	v_border_white(b_menu3,C_WHITE,100);
	v_border_arc  (b_menu3,C_WHITE,100);
}

void a_menu4()
{
	wait(1);my.material = mtl_zwenable;set(my,UNLIT | LIGHT | TRANSLUCENT);vec_set(my.pan, vector(0.01,0,0));
	bmap_fill(b_create_yellow,C_GREEN,100);
	BMAP* b_menu4 = ent_setskin(my,b_create_yellow,1);
	v_border_erase(b_menu4,C_BLACK,0);
	v_border_white(b_menu4,C_WHITE,100);
	v_border_arc  (b_menu4,C_WHITE,100);
}

void a_menu5()
{
	wait(1);my.material = mtl_zwenable;set(my,UNLIT | LIGHT | TRANSLUCENT);vec_set(my.pan, vector(0.01,0,0));
	bmap_fill(b_create_cyan,C_CYAN,100);
	BMAP* b_menu5 = ent_setskin(my,b_create_cyan,1);
	v_border_erase(b_menu5,C_BLACK,0);
	v_border_white(b_menu5,C_WHITE,100);
	v_border_arc  (b_menu5,C_WHITE,100);
}

void a_menu6()
{
	wait(1);my.material = mtl_zwenable;set(my,UNLIT | LIGHT | TRANSLUCENT);vec_set(my.pan, vector(0.01,0,0));
	bmap_fill(b_create_magenta,C_GREEN,100);
	BMAP* b_menu6 = ent_setskin(my,b_create_magenta,1);
	v_border_erase(b_menu6,C_BLACK,0);
	v_border_white(b_menu6,C_WHITE,100);
	v_border_arc  (b_menu6,C_WHITE,100);
}

void a_menu7()
{
	wait(1);my.material = mtl_zwenable;set(my,UNLIT | LIGHT | TRANSLUCENT);vec_set(my.pan, vector(0.01,0,0));
	bmap_fill(b_create_white,C_BLUE,100);
	BMAP* b_menu7 = ent_setskin(my,b_create_white,1);
	v_border_erase(b_menu7,C_BLACK,0);
	v_border_white(b_menu7,C_WHITE,100);
	v_border_arc  (b_menu7,C_WHITE,100);
}

void a_menu8()
{
	wait(1);my.material = mtl_zwenable;set(my,UNLIT | LIGHT | TRANSLUCENT);vec_set(my.pan, vector(0.01,0,0));
	bmap_fill(b_create_gray,C_GREEN,100);
	BMAP* b_menu8 = ent_setskin(my,b_create_gray,1);
	v_border_erase(b_menu8,C_BLACK,0);
	v_border_white(b_menu8,C_WHITE,100);
	v_border_arc  (b_menu8,C_WHITE,100);
}

void a_menu9()
{
	wait(1);my.material = mtl_zwenable;set(my,UNLIT | LIGHT | TRANSLUCENT);vec_set(my.pan, vector(0.01,0,0));
	bmap_fill(b_create_braun,C_RED,100);
	BMAP* b_menu9 = ent_setskin(my,b_create_braun,1);
	v_border_erase(b_menu9,C_BLACK,0);
	v_border_white(b_menu9,C_WHITE,100);
	v_border_arc  (b_menu9,C_WHITE,100);
}

void remove_bullets()
{
	speed_x += 0.01;
	my.event = NULL;
	wait (1);
	ent_remove (my);
}

void move_bullets()
{
	wait(1);my.material = mtl_zwenable;
	bmap_fill(b_bullet,C_YELLOW,100);
	ent_setskin(my,b_bullet,1);
	set(my,UNLIT | LIGHT );vec_set(my.pan, vector(0.001,0,0));
	VECTOR bullet_speed[3];	
	my.emask = ENABLE_IMPACT | ENABLE_ENTITY;
	my.event = remove_bullets;
	my.pan = you.pan;
	my.y = you.y;
	my.z = you.z + 30;
	bullet_speed.x = 0;
	bullet_speed.y = 0;
	bullet_speed.z = 30 * time_step;
	
	while (my)
	{
		my.pan += 50 * time_step;
		c_move (my, vector(bullet_speed.x,bullet_speed.y,bullet_speed.z), nullvector, IGNORE_YOU);
		if (my.z>400) {wait(1);ent_remove (my);}
		wait (1);
	}
}

void remove_player()
{ 
	wait(1);
	players_energy -= 20;
	wait(1);
}

void a_player()
{
	wait(1);my.material = mtl_zwenable;set(my,UNLIT | LIGHT);vec_set(my.pan, vector(0.001,0,0));
	vec_set(my.scale_x, vector(4,4,0));
	my.emask = ENABLE_IMPACT | ENABLE_ENTITY;
	my.event = remove_player;
	
	VECTOR temp;
	var speed = 80;
	
	while (players_energy > 1)
	{
		e_player.skill2 = 62;// // 14-(62.66) 15-(67.71) 16-(72.76)
		e_player.skill1 += 10 * time_step;
		if (e_player.skill1 > 4) e_player.skill1 -= 4;
		ent_animate(e_player,"",e_player.skill2+e_player.skill1,ANM_CYCLE);
		
		temp.y = speed * (mouse_force.x - mouse_force.y) * time_step; temp.x = 0; temp.z = 0;
		c_move (my, vector(0,temp.y,0), nullvector, IGNORE_PASSABLE | GLIDE);
		my.y = clamp(my.y, -450, 450);
		
		if ((mouse_left) && (total_frames % 15) == 1)
		{
			midiOutShortMsg(hMidiout, 0x007F7FC0);
			midiOutShortMsg(hMidiout, 0x007F1D90);wait(1);
			midiOutShortMsg(hMidiout, 0x007F1DA0);wait(5);
			midiOutShortMsg(hMidiout, 0x00001D80);
			e_bullet = ent_create("bullet.jpg",vector(100,0,-1000),move_bullets);
		}
		wait (1);
	}
}

void remove_ufo()
{
	midiOutShortMsg(hMidiout, 0x007F55C0);
	midiOutShortMsg(hMidiout, 0x007F2D90);wait(1);
	midiOutShortMsg(hMidiout, 0x007F2DA0);wait(5);
	midiOutShortMsg(hMidiout, 0x00002D80);
	
	set(my, INVISIBLE);//wait(1);
	e_explode = ent_create("enemies+21.tga",vector(my.x,my.y,my.z),a_exp_a1);
	wait(1);
	players_score += 100;
	ent_remove(me);
}

void a_ufo()
{
	wait(1);my.material = mtl_zwenable;set(my,UNLIT | LIGHT);vec_set(my.pan, vector(0.001,0,0));
	vec_set(my.scale_x, vector(4,4,0));
	my.emask = ENABLE_IMPACT | ENABLE_ENTITY;
	my.event = remove_ufo;
	
	VECTOR temp;
	var speed = -20;
	
	while(my.y>-600 && menu_status == 2)
	{	
		my.skill2 = 53;// 12-(53.57) 13-(58.61)
		my.skill1 += 3 * time_step;
		if (my.skill1 > 8) my.skill1 -= 8;
		ent_animate(me,"",my.skill2+my.skill1,ANM_CYCLE);
		
		temp.y = speed * time_step;
		c_move (my, vector(0,temp.y,0), nullvector, IGNORE_YOU);
		while((total_frames % 15) == 1)
		{
			midiOutShortMsg(hMidiout, 0x00305AC0); 
			midiOutShortMsg(hMidiout, 0x00304D90);wait(2);
			midiOutShortMsg(hMidiout, 0x00304D80);
		}
		wait(1);
	}
	midiOutShortMsg(hMidiout, 0x00004D90);
	wait(1);
	ent_remove(my);
}

void c_enemies()
{
	var i;
	while (1)
	{
		my.y += speed_x * sense_x * time_step;
		if ((my.y < -500) || (my.y > 500))
		{
			midiOutShortMsg(hMidiout, 0x00001C90);  // all notes off
			midiOutShortMsg(hMidiout, 0x00001D90);
			midiOutShortMsg(hMidiout, 0x00002D90);
			midiOutShortMsg(hMidiout, 0x00003D90);
			midiOutShortMsg(hMidiout, 0x00004D90);			
			sense_x *= -1;
			for(i=0; i<12; i++)
			{
				enemies1[i].z -= speed_y * time_step;
				enemies2[i].z -= speed_y * time_step;
				enemies3[i].z -= speed_y * time_step;
				enemies4[i].z -= speed_y * time_step;
				enemies5[i].z -= speed_y * time_step;
				enemies6[i].z -= speed_y * time_step;
			}
			/*
			enemies1[0].y -= 3.2; // right side 
			enemies2[0].y -= 0.8;
			enemies3[0].y -= 2;
			enemies4[0].y -= 2;
			enemies5[0].y -= 2;
			enemies6[0].y -= 2;
			
			enemies1[9].y += 0.9; // left side
			//enemies2[9].y -= 1.3;
			//enemies3[9].y -= 1.5;
			//enemies4[9].y -= 1.5;
			//enemies5[9].y -= 1.5;
			//enemies6[9].y -= 1.5;
			*/
		}
		if (my.z < -300){ init_menu(); break;}
		wait (1);
		while((total_frames % 15) == 1)
		{
			midiOutShortMsg(hMidiout, 0x002067C0); 
			midiOutShortMsg(hMidiout, 0x00201D90);wait(2);
			midiOutShortMsg(hMidiout, 0x00201D80);
		}
	}
}

void a_exp_a1()
{
	wait(1); my.material = mtl_zwenable; set(my,UNLIT | LIGHT | PASSABLE);vec_set(my.pan, vector(0.001,0,0));
	vec_set(my.scale_x, vector(4,4,4));
	var i=0;
	while (i<10)
	{
		my.skill2 = 50;// 11-(48.52)
		//my.skill1 += 1 * time_step;
		//if (my.skill1 > 1) my.skill1 -= 1; 
		ent_animate(me,"",my.skill2,ANM_CYCLE);
		i++;
		wait (1);
	}
	wait(1);
	ent_remove(my);
}

void remove_aliens1()
{  
	enemies_nr--;
	midiOutShortMsg(hMidiout, 0x007F50C0);
	midiOutShortMsg(hMidiout, 0x007F2D90);wait(1);
	midiOutShortMsg(hMidiout, 0x007F2DA0);wait(5);
	midiOutShortMsg(hMidiout, 0x00002D80);
	set(my, INVISIBLE);wait(1);
	e_explode = ent_create("enemies+21.tga",vector(my.x,my.y,my.z),a_exp_a1);
	players_score += 10;
	my.event = NULL;
	wait (1);
	ent_remove (my);
	speed_x += 0.01;
	speed_y += 0.01;
}

void remove_alien_bullets()
{
	players_energy -= 1;
	my.event = NULL;
	wait (1);
	ent_remove (my);
}

void alien_bullet()
{
	wait(1);my.material = mtl_zwenable;
	bmap_fill(b_abullet,C_RED,100);
	ent_setskin(my,b_bullet,1);
	set(my,UNLIT | LIGHT );vec_set(my.pan, vector(0.001,0,0));
	VECTOR bullet_speed[3];	
	my.emask = ENABLE_IMPACT | ENABLE_ENTITY;
	my.event = remove_alien_bullets;
	my.pan = you.pan;
	my.y = you.y;
	my.z = you.z - 30;
	bullet_speed.x = 0;
	bullet_speed.y = 0;
	bullet_speed.z = -30 * time_step;
	
	while (my)
	{
		my.pan += 50 * time_step;
		c_move (my, vector(bullet_speed.x,bullet_speed.y,bullet_speed.z), nullvector, IGNORE_YOU);
		if (my.z>400) {wait(1);ent_remove (my);}
		wait (1);
	}
}

void a_aliens1()
{
	wait(1);
	my.material = mtl_zwenable; set(my,UNLIT | LIGHT);vec_set(my.pan, vector(0.001,0,0));
	vec_set(my.scale_x, vector(4,4,0));
	my.emask |= (ENABLE_IMPACT | ENABLE_ENTITY);
	my.event = remove_aliens1;
	c_enemies();
	midiOutShortMsg(hMidiout, 0x00002D80);
	while (1)
	{
		my.skill2 = 20;// 5-(20.23) 6-(24.28)
		my.skill1 += 2 * time_step;
		//my.y = clamp(my.y, -450, 450);
		if (my.skill1 > 8) my.skill1 -= 8;
		ent_animate(me,"",my.skill2+my.skill1,ANM_CYCLE);
		/*
		if (total_frames % 15 == 1)
		{
		   wait(1);
			midiOutShortMsg(hMidiout, 0x007F7FC0);
			midiOutShortMsg(hMidiout, 0x007F1D90);wait(1);
			midiOutShortMsg(hMidiout, 0x007F1DA0);wait(5);
			midiOutShortMsg(hMidiout, 0x00001D80);
			e_bullet = ent_create("bullet.jpg",vector(100,0,-1000),alien_bullet);
		}*/
		wait (1);
	}
}

void remove_aliens2()
{  
	enemies_nr--;
	midiOutShortMsg(hMidiout, 0x007F50C0);
	midiOutShortMsg(hMidiout, 0x007F3D90);wait(1);
	midiOutShortMsg(hMidiout, 0x007F3DA0);wait(5);
	midiOutShortMsg(hMidiout, 0x00003D80);
	set(my, INVISIBLE);wait(1);
	e_explode = ent_create("enemies+21.tga",vector(my.x,my.y,my.z),a_exp_a1);      
	players_score += 20;
	my.event = NULL;
	wait (1);
	ent_remove (my);
	speed_x += 0.01;
	speed_y += 0.01;
}

void a_aliens2()
{
	wait(1);
	my.material = mtl_zwenable; set(my,UNLIT | LIGHT);vec_set(my.pan, vector(0.001,0,0));
	vec_set(my.scale_x, vector(4,4,0));
	my.emask = ENABLE_IMPACT | ENABLE_ENTITY;
	my.event = remove_aliens2;
	c_enemies();
	midiOutShortMsg(hMidiout, 0x00003D80);
	while (1)
	{
		my.skill2 = 29;// 7-(29.33) 8-(34.38)
		my.skill1 += 2 *time_step;
		//my.y = clamp(my.y, -450, 450);
		if (my.skill1 > 9) my.skill1 -= 9;
		ent_animate(me,"",my.skill2+my.skill1,ANM_CYCLE);
		wait (1);
	}
}

void remove_aliens3()
{  
	enemies_nr--;
	midiOutShortMsg(hMidiout, 0x004050C0);        // Instrument
	midiOutShortMsg(hMidiout, 0x00404D90);wait(1);// note octave on
	midiOutShortMsg(hMidiout, 0x00404DA0);wait(5);// Aftertouch
	midiOutShortMsg(hMidiout, 0x00004D80);
	set(my, INVISIBLE);wait(1);
	e_explode = ent_create("enemies+21.tga",vector(my.x,my.y,my.z),a_exp_a1);     
	players_score += 30;
	my.event = NULL;
	wait (1);
	ent_remove (my);
	speed_x += 0.01;
	speed_y += 0.01;
}

void a_aliens3()
{
	wait(1);
	my.material = mtl_zwenable; set(my,UNLIT | LIGHT);vec_set(my.pan, vector(0.001,0,0));
	vec_set(my.scale_x, vector(4,4,0));
	my.emask = ENABLE_IMPACT | ENABLE_ENTITY;
	my.event = remove_aliens3;
	c_enemies();
	midiOutShortMsg(hMidiout, 0x00004D80);
	while (1)
	{
		my.skill2 = 39;// 9-(39.42) 10-(43.47)
		my.skill1 += 2 *time_step;
		//my.y = clamp(my.y, -450, 450);
		if (my.skill1 > 8) my.skill1 -= 8;
		ent_animate(me,"",my.skill2+my.skill1,ANM_CYCLE);
		wait (1);
	}
}

void create_enemies()
{
	var temp1 = 300, temp2 = 100, i=0;
	e_player = ent_create("enemies+21.tga",vector(temp2,temp1,-300),a_player);
	wait(1);
	
	while (i < 12)
	{
		enemies1[i] = ent_create("enemies+21.tga",vector(temp2,temp1,   0),a_aliens1);
		enemies2[i] = ent_create("enemies+21.tga",vector(temp2,temp1,  60),a_aliens1);
		enemies3[i] = ent_create("enemies+21.tga",vector(temp2,temp1, 120),a_aliens2);
		enemies4[i] = ent_create("enemies+21.tga",vector(temp2,temp1, 180),a_aliens2);
		enemies5[i] = ent_create("enemies+21.tga",vector(temp2,temp1, 240),a_aliens3);
		enemies6[i] = ent_create("enemies+21.tga",vector(temp2,temp1, 300),a_aliens3);
		i ++;
		temp1 -= 70;
	}
}

void create_b_arrow()
{
	v_line  (b_arrowx,C_YELLOW,100);
	v_arc   (b_arrowx,C_YELLOW,100);
	v_circle(b_arrowx,C_BLACK ,0);
	b_arrowa  = bmap_blitpart(bmap_createblack(42,42,32), b_arrowx, vector(0, 0, 0), vector(0,0,0), vector(0, 0, 0), vector(42,42,0));
	mouse_map = b_arrowa;
}

void init_game()
{
	wait(1);
	ptr_remove(e_player);
	speed_x += 0.1;
	speed_y += 0.2;
	enemies_nr = 72;
	//wait(1);
	var j;
	for (j=0; j<12; j++)
	{
		ptr_remove(enemies1[j]);
		ptr_remove(enemies2[j]);
		ptr_remove(enemies3[j]);
		ptr_remove(enemies4[j]);
		ptr_remove(enemies5[j]);
		ptr_remove(enemies6[j]);
		//wait(1);
	}
	create_enemies();
	wait(10);
}

void game_over()
{
	midiOutShortMsg(hMidiout, 0x00407EC0);         // Instrument
	midiOutShortMsg(hMidiout, 0x00403D90);wait(1); // note & octave on
	midiOutShortMsg(hMidiout, 0x00403DA0);wait(10);// Aftertouch
	midiOutShortMsg(hMidiout, 0x00003D80);         // or note off
	vec_set(p_game_over.pos_x, vector(hsmx,hsmy-50,0));
	set(p_game_over, CENTER_X | SHOW);
	wait(-0.3);
	reset(p_game_over, CENTER_X | SHOW);
	speed_x =  5;
	speed_y = 75;
}

void init_menu()
{
   while (i<200)
	{
		e_player.skill2 = 67;// 15-(67.71) 16-(72.76)
		e_player.skill1 += 10 * time_step;
		if (e_player.skill1 > 9) e_player.skill1 -= 9;
		ent_animate(e_player,"",e_player.skill2+e_player.skill1,ANM_CYCLE);
		i++;
		wait (1);
	}
	var i,j;
	for (j=0; j<12; j++)
	{
		ptr_remove(enemies1[j]);
		ptr_remove(enemies2[j]);
		ptr_remove(enemies3[j]);
		ptr_remove(enemies4[j]);
		ptr_remove(enemies5[j]);
		ptr_remove(enemies6[j]);
		//wait(1);
	}
	game_over();
	ptr_remove(e_player);
	mouse_map = b_arrowa;
	players_energy = 100;
	players_score = 0;
	enemies_nr = 72;
	menu_status = 1;
}

void mouse_start()
{  
	while (1){vec_set(mouse_pos, mouse_cursor);wait(1);}
}

void main()
{
	wait(1);
	video_window(vector(0,sm1_y,0),vector(768,128,0),0,NULL); // vector(106,2,0) minimum !
	video_set(768, 128, 32, 2);

	bmap_fill(b_sky1,C_GRAY,100);
	bmap_fill(b_sky2,C_GRAY,100);
	bmap_fill(b_sky3,C_GRAY,100);
	bmap_fill(b_sky4,C_GRAY,100);
	bmap_fill(b_sky5,C_GRAY,100);
	bmap_fill(b_sky6,C_GRAY,100);

	set(p_sky1, FILTER | OUTLINE | CENTER_X | SHOW);set(p_sky2, CENTER_X | SHOW);set(p_sky3, CENTER_X | SHOW);
	set(p_sky4, CENTER_X | SHOW);set(p_sky5, CENTER_X | SHOW);set(p_sky6, CENTER_X | SHOW);

	file_for_screen("sky+.dds",6);
	wait(5);
	reset(p_sky1, FILTER | SHOW);reset(p_sky2, SHOW);reset(p_sky3, SHOW);
	reset(p_sky4, SHOW);reset(p_sky5, SHOW);reset(p_sky6, SHOW);
	wait(1);

	video_set(336, 8, 32, 2);

	var e_data[1536] = 
	{
		// enemies bits data
		0,0,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,0,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,1,0,0,1,0,1,0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,
		0,0,0,0,1,1,0,1,1,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,0,1,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,1,1,0,1,0,0,0,0,0,0,0,0,1,0,0,1,0,0,1,0,0,1,0,0,0,
		0,0,0,0,0,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,
		0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,1,1,1,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,
		0,0,1,1,0,0,1,1,0,0,1,1,1,1,0,0,0,0,1,1,1,1,0,0,1,1,0,0,1,1,0,0,0,0,0,1,1,0,1,1,1,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,
		0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,1,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,
		0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,1,0,0,0,1,0,0,
		0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,

		0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0, // ufo bits data
		0,0,1,1,1,0,0,1,1,0,0,1,1,1,0,0,0,0,1,1,1,0,0,1,1,0,0,1,1,1,0,0,
		0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
		0,1,1,0,1,1,0,1,1,0,1,1,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
		0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
		0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,
		0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,

		0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,1,1,1,1,1,1,1,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,0,1, // player bits data
		0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,0,0,
		0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,1,1,1,0,0,0,1,0,0,0,1,0,0,0,1,0,1,1,0,1,0,1,0,0,0,
		0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,1,0,1,1,0,0,1,1,0,0,0,1,0,0,0,0,0,0,0,1,1,0,1,1,0,0,0,0,
		0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,0,0,0,
		0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,
		0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0
		
	};
	
	bmap_fill(b_wpoint, C_WHITE,100);
	var pan_x, pan_y, index = 0;

	for (pan_y=0; pan_y<8; pan_y++)
	{
		for (pan_x=64; pan_x<176; pan_x++)
		{
			index++;
			if (e_data[index]==1)
			{
				new_element[index] = pan_create(c_wpoint, index);
				vec_add (new_element[index].pos_x,vector(pan_x+1,pan_y,0));
			}
			//wait(1);
		}
	}

	bmap_fill(b_rpoint, C_RED,100);

	for (pan_y=0; pan_y<8; pan_y++)
	{
		for (pan_x=177; pan_x<209; pan_x++)
		{
			index++;
			if (e_data[index]==1)
			{
				new_element[index] = pan_create(c_rpoint, index);
				vec_add (new_element[index].pos_x,vector(pan_x,pan_y,0));
			}
			//wait(1);
		}
	}

	bmap_fill(b_gpoint, C_GREEN,100);

	for (pan_y=0; pan_y<8; pan_y++)
	{
		for (pan_x=210; pan_x<258; pan_x++)
		{
			index++;
			if (e_data[index]==1)
			{
				new_element[index] = pan_create(c_gpoint, index);
				vec_add (new_element[index].pos_x,vector(pan_x,pan_y,0));
			}
			//wait(1);
		}
	}

	// only the .tga format can save the picture as transparent bitmap animation for the sprites entities, but must be converted to Y axis!
	file_for_screen("enemies+.tga",21);
	wait(5);

	for (n=1; n<1536; n++)
	{
		ptr_remove(new_element[n]);
		//wait(1);
	}
	
	//d3d_antialias = 1;
	
	sun_light = 0;
	camera.clip_near = 0;
	camera.clip_far = 100000;
	camera.arc = 90;
	mouse_mode = 1;
	vec_set(sky_color,vector(1,0,0));
	video_set(sm0_x, sm1_y, 32, 1);
	
	ent_createlayer("sky+6.dds", SKY | CUBE | SHOW, 1);
	level_load("");
	wait(3);

	//midiOutOpen(&hMidiout, MIDI_MAPPER, 0, 0, 0);
	midiOutOpen(&hMidiout, midiport, 0, 0, CALLBACK_NULL);

	//UINT result = midiOutOpen(&hMidiout, MIDI_MAPPER, 0, 0, 0);
	//if(result != MMSYSERR_NOERROR) printf("No MIDI output devices!",0);

	//vec_set(p_menu.pos_x, vector(hsmx,0,0));
	//set(p_menu, CENTER_X | OUTLINE | SHOW);
	
	//vec_set(p_score.pos_x, vector(hsmx,0,0));
	//set(p_score, CENTER_X | OUTLINE | SHOW);
	set(p_score, OUTLINE | SHOW);
	
	vec_set(p_energy.pos_x, vector((sm0_x-535),0,0));
	set(p_energy,OUTLINE | SHOW);

	create_b_arrow();
	mouse_start();

	bmap_save(bmap_createblack(256,128,32),"empty1.jpg");
	bmap_save(bmap_createblack(256,128,32),"empty2.jpg");
	bmap_save(bmap_createblack(256,128,32),"empty3.jpg");
	bmap_save(bmap_createblack(256,128,32),"empty4.jpg");
	bmap_save(bmap_createblack(256,128,32),"empty5.jpg");
	bmap_save(bmap_createblack(256,128,32),"empty6.jpg");
	bmap_save(bmap_createblack(256,128,32),"empty7.jpg");
	bmap_save(bmap_createblack(256,128,32),"empty8.jpg");
	bmap_save(bmap_createblack(256,128,32),"empty9.jpg");
	bmap_save(bmap_createblack(  8, 16,32),"bullet.jpg");

	e_menu0 = ent_create("",          vector(  0,   0,   0),a_menu0);wait(3);
	e_menu1 = ent_create("empty1.jpg",vector(  0,-330, 200),a_menu1);wait(3);
	e_menu2 = ent_create("empty2.jpg",vector(  0,   0, 200),a_menu2);wait(3);
	e_menu3 = ent_create("empty3.jpg",vector(  0, 330, 200),a_menu3);wait(3);
	e_menu4 = ent_create("empty4.jpg",vector(  0,-330,   0),a_menu4);wait(3);
	e_menu5 = ent_create("empty5.jpg",vector(  0,   0,   0),a_menu5);wait(3);
	e_menu6 = ent_create("empty6.jpg",vector(  0, 330,   0),a_menu6);wait(3);
	e_menu7 = ent_create("empty7.jpg",vector(  0,-330,-200),a_menu7);wait(3);
	e_menu8 = ent_create("empty8.jpg",vector(  0,   0,-200),a_menu8);wait(3);
	e_menu9 = ent_create("empty9.jpg",vector(  0, 330,-200),a_menu9);wait(3);


	var rotspd = 1;
	var minang = -35;
	var maxang =  35;
	var temp[3];
	VECTOR tmp;
	var cam_dist=700;
	ANGLE cam_ang;
	cam_ang.pan =  e_menu0.pan;
	cam_ang.tilt = e_menu0.tilt-10;
	cam_ang.roll = e_menu0.roll;

	ENTITY* m_ent = ent_create(NULL,nullvector,NULL);
	ENTITY* m_tmp = ent_create(NULL,nullvector,NULL);

	while(1)
	{
	   if (enemies_nr<1) init_game();
		if(menu_status==10) speed_x +=  1;
		{
			while((total_frames % 500) == integer(random(3))) 
			{
			   wait(1);
				e_ufo = ent_create("enemies+21.tga",vector(100,600,350),a_ufo);
				wait(1);
			}
		}
		if (mouse_left && mouse_ent == e_menu5 && menu_status == 1)
		{
			midiOutShortMsg(hMidiout, 0x00001C90);  // all notes off
			midiOutShortMsg(hMidiout, 0x00001D90);
			midiOutShortMsg(hMidiout, 0x00002D90);
			midiOutShortMsg(hMidiout, 0x00003D90);
			midiOutShortMsg(hMidiout, 0x00004D90);
			mouse_map = NULL;
			reset(p_play, SHOW);
			menu_status=2;
			create_enemies();
			wait(10);
		}
		
		if(mouse_ent && menu_status==1)
		{
			m_ent = mouse_ent;
			if(m_ent == e_menu5)
			{
				while((total_frames % 15) == 1)
				{
					midiOutShortMsg(hMidiout, 0x004030C0); 
					midiOutShortMsg(hMidiout, 0x00401C90);wait(5);
					midiOutShortMsg(hMidiout, 0x00401C80);
				}
				vec_set(p_play.pos_x, vector(hsmx,hsmy-50,0));
				set(p_play, OUTLINE | CENTER_X | SHOW);
				vec_set(m_ent.x, vector(10,m_ent.y,m_ent.z));
				vec_set(m_ent.scale_x, vector(1.2,1.2,0));
				m_tmp = m_ent;
			}
			else
			{
				if(e_menu0)
				{
					midiOutShortMsg(hMidiout, 0x00001C80);
					reset(p_play, SHOW);
					vec_set(m_tmp.x, vector(0,m_tmp.y,m_tmp.z));
					vec_set(m_tmp.scale_x, vector(1,1,0));
				}
			}
		}
		else
		{
			vec_set(m_ent.x, vector(0,m_ent.y,m_ent.z));
			vec_set(m_ent.scale_x, vector(1,1,0));
		}

		if (mouse_pos.x < 0)
		{
			cam_ang.pan  -= rotspd * mouse_force.x;
		}
		else
		{
			cam_ang.pan  += rotspd * mouse_force.x;
		}
		if (mouse_pos.y < 0)
		{
			cam_ang.tilt  -= rotspd * mouse_force.y;
		}
		else
		{
			cam_ang.tilt  += rotspd * mouse_force.y;
		}

		cam_ang.pan  = clamp(cam_ang.pan , minang, maxang);
		cam_ang.tilt = clamp(cam_ang.tilt, minang, maxang);

		cam_dist -= integer(mickey.z);
		cam_dist = clamp(cam_dist, mindist, maxdist);

		vec_set(tmp,e_menu0.x);
		camera.x = tmp.x + cos(cam_ang.pan) * (cam_dist*cos(cam_ang.tilt));
		camera.y = tmp.y + sin(cam_ang.pan) * (cam_dist*cos(cam_ang.tilt));
		camera.z = tmp.z + sin(cam_ang.tilt)*  cam_dist;
		vec_sub(tmp,camera.x);
		vec_to_angle(camera.pan,tmp);
		wait(1);
	}
}
void on_esc_event()
{
	wait(1);
	midiOutReset(hMidiout);wait(1);
	midiOutClose(hMidiout);wait(1);
	sys_exit(NULL);
}